<template>
  <div class="sw-gs-cms-element-like" v-if="isClient || isGuideActingForUser">
    <SwButton class="sw-gs-cms-element-like-like-btn is-circle"
              :class="colorClass"
              :title="$t('Like')"
              :disabled="likeLoading"
              @click="likeHandler">
      <SfLoader :loading="likeLoading">
        <div v-if="productLiked">
          <SwGsIconThumbsUp class="color-dark-secondary size-sm is-on-list"/>
        </div>
        <div v-else>
          <SwGsIconThumbsUp class="color-dark-secondary size-sm is-not-on-list"/>
        </div>
      </SfLoader>
    </SwButton>

    <SwButton class="sw-gs-cms-element-like-dislike-btn is-circle"
              :class="colorClass"
              :title="$t('Dislike')"
              :disabled="dislikeLoading"
              @click="dislikeHandler">
      <SfLoader :loading="dislikeLoading">
        <div v-if="productDisliked">
          <SwGsIconThumbsDown class="color-dark-secondary size-sm is-on-list"/>
        </div>
        <div v-else>
          <SwGsIconThumbsDown class="color-dark-secondary size-sm is-not-on-list"/>
        </div>
      </SfLoader>
    </SwButton>
  </div>
</template>

<script>
import { computed, ref, inject } from "@vue/composition-api"
import SwButton from "@/components/atoms/SwButton.vue";
import { SfLoader } from "@storefront-ui/vue";
import { useCms } from "@shopware-pwa/composables"
import { useLikeList } from "../../logic/composables/useLikeList";
import {SwGsIconThumbsDown, SwGsIconThumbsUp} from "../../components/icons";
import {useAppointment} from "../../logic/composables/useAppointment";
import {useState} from "../../logic/composables/useState";

export default {
  name: "CmsElementLike",

  components: {
    SwButton,
    SfLoader,
    SwGsIconThumbsDown,
    SwGsIconThumbsUp
  },

  props: {
    content: {
      type: Object,
      default: () => ({}),
    },
    color: {
      type: String,
      default: "light",
    },
  },

  setup(props) {
    const { page } = useCms() // fallback for provide/inject, remove in future
    const cmsPage = inject("cms-page", page)
    const product = computed(() => cmsPage.value?.product)

    const { like, dislike, removeFromLikeList, removeFromDislikeList, productLiked, productDisliked } = useLikeList(product.value);
    const { isGuide, isClient } = useAppointment();
    const { currentClientForGuide, stateForAll } = useState();


    const likeLoading = ref(false);
    const dislikeLoading = ref(false);

    async function likeHandler() {
      likeLoading.value = true;
      if (productLiked.value === true ) {
        await removeFromLikeList();
      } else {
        await like();
      }
      likeLoading.value = false;
    }

    async function dislikeHandler() {
      dislikeLoading.value = true;
      if (productDisliked.value === true ) {
        await removeFromDislikeList();
      } else {
        await dislike();
      }
      dislikeLoading.value = false;
    }

    const colorClass = computed(() => 'color-' + props.color);

    return {
      product,
      likeHandler,
      dislikeHandler,
      productLiked,
      productDisliked,
      likeLoading,
      dislikeLoading,
      isGuide,
      isClient,
      colorClass,
      currentClientForGuide,
      isGuideActingForUser: computed(() => isGuide.value && currentClientForGuide.value && stateForAll.value?.allowUserActionsForGuide)
    }
  }
}
</script>

<style lang="scss" scoped>
  .sw-gs-cms-element-like {
    display: flex;
  }

  .sw-gs-cms-element-like-like-btn  {
    .is-on-list {
      --icon-color: var(--c-success);
    }
  }

  .sw-gs-cms-element-like-dislike-btn {
    margin-left: 15px;

    .is-on-list {
      --icon-color: var(--c-danger);
    }
  }

  .sw-gs-cms-element-like-like-btn,
  .sw-gs-cms-element-like-dislike-btn {
    width: 64px;
    height: 64px;
  }

  ::v-deep {
    .sf-loader {
      width: 22px;
      height: 22px;
    }

    .sf-loader__overlay {
      background: none;
    }
  }
</style>
